// Vertex Shader  file "planet_shader.vert"

#version 330 core

uniform mat4 MVP;
uniform mat4 M;
uniform mat4 V;
uniform mat4 tex_mat;

in  vec4 in_position;
in  vec4 in_color;
in	vec4 in_normal;
in  vec4 in_texture_coords;

out vec4 ex_color;
out vec3 position;
out vec3 light_direction;
out vec3 eye_direction;
out vec3 normal;
out vec2 ex_texture_coords;
out vec4 sm_tex_coords;

void main(void)
{
	gl_Position = MVP * in_position;

	position = (M * in_position).xyz;
	eye_direction = (V * M * in_position).xyz;
	light_direction = (V * vec4(20, 0, 0, 1)).xyz - eye_direction;

	normal = (V * M * in_normal).xyz;
	
	ex_color = in_color;
	ex_texture_coords = in_texture_coords.xy;

	sm_tex_coords = tex_mat * in_position;
}